Option Explicit Off
Option Strict Off

Imports System.Double
Imports System.Diagnostics.Debug


Module Module1

    Sub Test()
        Msg = "Module1"
        MsgBox(Msg.GetType().Name())
    End Sub

    Sub TestStrictMode()
        Dim I As Integer = 5
        Dim L As Long = 100000000000
        I = L
        MsgBox(I)
    End Sub


End Module


Module Module2

  Sub Test()
    MsgBox("Module2")
  End Sub

End Module


Module DemoDataTypes


  Sub MembersOf()

    Dim I As Integer

    Debug.WriteLine(I.GetType())
    Debug.WriteLine(I.MaxValue)
    Debug.WriteLine(Integer.MaxValue)

    Debug.WriteLine(I.CompareTo(S))

    Dim Test As Boolean
    Test = (Integer.MinValue < 100000) And (100000 < Integer.MaxValue)
    Debug.WriteLine(Test)
    Debug.WriteLine(Integer.Parse(100000))

    Dim Number As String
    Number = "4"
    Debug.WriteLine(Integer.Parse(Number))
    MsgBox(Number.GetHashCode())

    Dim J As Integer

    J = I
    Test = I.CompareTo(J)
    Debug.WriteLine(Test)
    Debug.WriteLine(I.Equals(J))

    MsgBox(I.GetTypeCode())

  End Sub

  Sub TestFloatingPoint()

    Dim S As Single
    S = S * 10000

    MsgBox(S = 0)

    Dim D As Double

    D = 5
    I = -5

    D = I / 0

    MsgBox("IsInfinity:" + Double.IsInfinity(I / 0))

    MsgBox(I / 0)

    MsgBox(Math.Sqrt(-1))

    MsgBox(D.Epsilon)
    MsgBox(Single.Epsilon)

  End Sub

  Sub TestDecimal()
    Dim D1, D2 As Decimal
    MsgBox(Decimal.Compare(D1, D2))
    D1 = 10
    D2 = 5.7
    MsgBox(Decimal.Divide(D1, D2))
    MsgBox(Decimal.Floor(5.7))

    MsgBox(Decimal.GetBits(3).GetValue(0))

  End Sub


  Sub TestDecimalOperators()
    Dim L As ValueType

    Dim Dec1, Dec2 As Decimal
    Dec1 = 100
    Dec2 = 200

    Dec1 = Dec1 + Dec2
    Dec1 = --Dec1
    Dec1 = ++Dec2
  End Sub

  Sub TestChar()
    MsgBox(Char.ToUpper("a"))

  End Sub

  Sub PrzykladyMetodKlasyString()

    Dim S As String = _
      "Witamy w swiecie nieskonczonych mozliwosci programowania"
    Dim T As String = S.Clone()

    Debug.WriteLine(S.ToLower())
    Debug.WriteLine(S.ToUpper())
    Debug.WriteLine(T.EndsWith("programowania"))
    Debug.WriteLine(S.Chars(5))
    Debug.WriteLine(String.Concat("Hello", " ", "World"))
    Debug.WriteLine(S.Substring(5, 10))

    Debug.WriteLine(String.Format( _
     "Abraham Lincoln urodzi si {0:s}", "12. lutego"))

    Dim Enumerator As CharEnumerator = S.GetEnumerator

    While (Enumerator.MoveNext())
      Debug.WriteLine(Enumerator.Current())
    End While

    Dim R() As String = {"2", "12", "1966"}
    MsgBox(S.Join("/", R))

  End Sub

  Sub TestBooleans()

    Dim B As Boolean
    B = False Or True
    Debug.WriteLine(B)

    B = False Xor False
    Debug.WriteLine(B)

    B = False And True
    Debug.WriteLine(B)

    B = Not True
    Debug.WriteLine(B)


    Dim I As Integer


    I = 3 Or 4
    Debug.WriteLine(I)

    I = 2 And 4
    Debug.WriteLine(I)

    I = 3 Xor 3
    Debug.WriteLine(I)

    I = Not 5
    Debug.WriteLine(I)

  End Sub

  Sub TestDateTime()

    Debug.WriteLine(DateTime.FromOADate(0.5))
    Debug.WriteLine(DateTime.Parse("12:00:00 PM"))
    Dim Provider As New System.Globalization.DateTimeFormatInfo()
    Debug.WriteLine(Provider.AMDesignator())
    Debug.WriteLine(DateTime.ParseExact("12:42", "hh:mm", Provider))

    Dim D As New DateTime()

    D = Now()

    Debug.WriteLine(D.ToUniversalTime())

    Debug.WriteLine("UTC-LocalTime=" + D.ToUniversalTime(). _
      Subtract(D).ToString())

    Debug.WriteLine("Impulsw od pnocy 1 stycznia 1 roku =" _
      + Now().Ticks().ToString())

  End Sub


End Module

